DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | Static Private Attributes | Friends | List of all members
DcmHashDict Class Reference

a hash table of pointers to DcmDictEntry objects More...

## Public Member Functions
| DcmHashDict ()
| default constructor
| ~DcmHashDict ()
| destructor
int | size () const
| counts total number of entries More...
void | clear ()
| clears the hash table of all entries
void | put (DcmDictEntry *entry)
| inserts an entry into hash table (deletes old entry if present) More...
const DcmDictEntry * | get (const DcmTagKey &key, const char *privCreator) const
| hash table lookup for the given tag key and private creator name More...
void | del (const DcmTagKey &key, const char *privCreator)
| deletes the entry for the given tag and private creator identifier More...
DcmHashDictIterator | begin () const
| returns iterator to start of hash table
DcmHashDictIterator | end () const
| returns iterator to end of hash table
STD_NAMESPACE ostream & | loadSummary (STD_NAMESPACE ostream &out)
| prints some information about hash table bucket utilization More...

## Private Member Functions
| DcmHashDict (const DcmHashDict &)
| private unimplemented copy constructor
DcmHashDict & | operator= (const DcmHashDict &)
| private unimplemented copy assignment operator
void | _init ()
| performs initialization for given hash table size, called from constructor
int | hash (const DcmTagKey *key, const char *privCreator) const
| compute hash value for given tag key More...
DcmDictEntry * | insertInList (DcmDictEntryList &lst, DcmDictEntry *entry)
| inserts new entry into given list More...
DcmDictEntry * | removeInList (DcmDictEntryList &lst, const DcmTagKey &key, const char *privCreator)
| removes the entry for the given tag and private creator identifier More...
DcmDictEntry * | findInList (DcmDictEntryList &lst, const DcmTagKey &key, const char *privCreator) const
| searches entry for the given tag and private creator identifier More...

## Private Attributes
DcmDictEntryList ** | hashTab
| array of (hash table size) pointers to DcmDictEntryList elements implementing the different buckets of the hash table
int | lowestBucket
| index of lowest bucket for which the DcmDictEntryList has been initialized
int | highestBucket
| index of highest bucket for which the DcmDictEntryList has been initialized
int | entryCount
| number of entries in hash table

## Static Private Attributes
static const int | hashTabLength
| number of buckets in hash table

## Friends
class | DcmHashDictIterator

## Detailed Description

a hash table of pointers to DcmDictEntry objects

## Member Function Documentation

## ◆ del()

void DcmHashDict::del | ( | const DcmTagKey & | key,
|  | const char * | privCreator
| ) |  |

deletes the entry for the given tag and private creator identifier

Parameters

  key | tag key of the entry to be deleted
  privCreator | private creator identifier, may be NULL

## ◆ findInList()

DcmDictEntry* DcmHashDict::findInList | ( | DcmDictEntryList & | lst,
|  | const DcmTagKey & | key,
|  | const char * | privCreator
| ) |  | const
| private

searches entry for the given tag and private creator identifier

Parameters

  lst | list to search in
  key | tag key of the entry to be searched for
  privCreator | private creator identifier, may be NULL

Returns
  pointer to found element, NULL if not found

## ◆ get()

const DcmDictEntry* DcmHashDict::get | ( | const DcmTagKey & | key,
|  | const char * | privCreator
| ) |  | const

hash table lookup for the given tag key and private creator name

Parameters

  key | tag key of the entry to be searched for
  privCreator | private creator identifier, may be NULL

Returns
  pointer to entry (if found), otherwise NULL

## ◆ hash()

int DcmHashDict::hash | ( | const DcmTagKey * | key,
|  | const char * | privCreator
| ) |  | const
| private

compute hash value for given tag key

Parameters

  key | pointer to tag key
  privCreator | private creator identifier, may be NULL

Returns
  hash value

## ◆ insertInList()

DcmDictEntry* DcmHashDict::insertInList | ( | DcmDictEntryList & | lst,
|  | DcmDictEntry * | entry
| ) |  |
| private

inserts new entry into given list

Parameters

  lst | list to add to
  entry | new element to add, will be deleted upon destruction of the hash table

Returns
  pointer to replaced element, if any

## ◆ loadSummary()

STD_NAMESPACE ostream& DcmHashDict::loadSummary | ( | STD_NAMESPACE ostream & | out | ) |

prints some information about hash table bucket utilization

Parameters

  out | the stream to print into

## ◆ put()

void DcmHashDict::put | ( | DcmDictEntry * | entry | ) |

inserts an entry into hash table (deletes old entry if present)

Parameters

  entry | pointer to new entry

## ◆ removeInList()

DcmDictEntry* DcmHashDict::removeInList | ( | DcmDictEntryList & | lst,
|  | const DcmTagKey & | key,
|  | const char * | privCreator
| ) |  |
| private

removes the entry for the given tag and private creator identifier

Parameters

  lst | list to remove from
  key | tag key of the entry to be removed
  privCreator | private creator identifier, may be NULL

Returns
  pointer to removed element, if any

## ◆ size()

int DcmHashDict::size | ( |  | ) | const
| inline

counts total number of entries

Returns
  number of entries

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dchashdi.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1